<template lang="pug">
mixin info(name)
  .row&attributes(attributes)
    .col-12.text-left.col-sm-3.col-lg-2
      strong= name
    .col-12.text-right.col-sm-9.col-lg-10.text-sm-left
      block
mixin spinner(text)
  .spinner-border.spinner-border-sm(role='status')
    span.sr-only= text

.row.x-runinfo
  .col-12.py-3
    .col-12.py-3.justify-content-center.d-flex(v-if='!loading && $butils.isNil(run)' key='noSuch')
      span.alert.alert-secondary Unknown Run
    .col-12(v-else key='run')
      BaseCard
        li(key='header')
          BaseAnimationBlock
            .justify-content-center.d-flex(v-if='!run || runLoading' key='loading')
              h5.m-0 #[i.align-bottom.fa.fa-spinner.fa-pulse]
            .d-flex.justify-content-between.align-items-center(v-else key='title')
              div.d-flex
                nav.justify-content-center(aria-label='Pagination')
                  ul.pagination
                    li.page-item
                      router-link.page-link(tag='button' type='button' :to='{ params: { id: id - 1 } }') #[i.fa.fa-angle-left]
                    li.page-item
                      router-link.page-link(tag='button' type='button' :to='parentPath') #[i.fa.fa-angle-up]
                    li.page-item
                      router-link.page-link(tag='button' type='button' :to='{ params: { id: id + 1 } }') #[i.fa.fa-angle-right]
                span
                  kbd.ml-1(v-if='showKeyHints') Ctrl-#[.fa.fa-caret-left]#[.fa.fa-caret-up.mx-1]#[.fa.fa-caret-right]
              h5.my-0.ml-2 {{ "#" + run.runNumber }}
              div.ml-auto.d-flex.justify-content-between
                button.x-update-triggers.btn.btn-outline-danger.mx-4(v-if="$store.getters.canAdmin && inEdit"
                  @click='updateTriggers()')
                  span.pr-2(v-if="updateTriggersOngoing")
                    +spinner('')
                  i(v-else).fas.fa-redo.pr-2
                  span Update Triggers
                .clickable(@click='setEdit(true)' v-if='canEdit && !inEdit')
                  kbd.mr-2(v-if="showKeyHints") E
                  i.fa.fa-cog
                .clickable(@click='setEdit(false)' v-if='canEdit && inEdit')
                  kbd.mr-2(v-if="showKeyHints") Esc
                  i.fa.fa-times
        li(v-if='run && !runLoading' key='info')
          
          +info('RunNumber') {{ run.runNumber }}
          +info('Title')(v-if='!inEdit') {{ run.title }}
          +info('Start') {{ run.start | dateTime }}
          +info('Stop')(v-if='run.stop') {{ run.stop | dateTime }}
          +info('Duration')(v-if='duration') {{ duration }}
          +info('Run Status')
            RunStatusIcon(:run='run')
              span.text-muted.small.align-top  ({{ run.runStatus }})
          +info('Data Status')
            template(v-if='!inEdit')
              DataStatusIcon(:run='run').mr-2
              span.text-muted.small.align-top ({{ run.dataStatus }})
            template(v-else)
              button.btn.btn-sm.btn-outline-primary.x-edit-data-status(v-if='inEdit' @click='doEditDataStatus')
                DataStatusIcon(:run='run').mr-2
                span.small.align-top ({{ run.dataStatus }})
                i.fa.fa-edit.ml-2
          +info('# Total Protons')(:title='run.totalProtons') {{ run.totalProtons | b-bigNumber }}
          +info('# Calibration Triggers')(:title='run.triggersCalibration')
            span(v-if="updateTriggersOngoing")
              +spinner('Loading...')
            span(v-else) {{ run.triggersCalibration }}
          +info('# Dedicated Triggers')(:title='run.triggersPrimary')
            span(v-if="updateTriggersOngoing")
              +spinner('Loading...')
            span(v-else) {{ run.triggersPrimary }}
          +info('# Parasitic Triggers')(:title='run.triggersParasitic')
            span(v-if="updateTriggersOngoing")
              +spinner('Loading...')
            span(v-else) {{ run.triggersParasitic }}
          +info('Archive Folder') {{ run.castorFolder }}
          +info('Material Setup')(v-if='$butils.isNil(run.matSetupId)') Not Set
          +info('Material Setup')(v-else-if='!matSetupLoading && matSetup')
            router-link.text-primary.text-truncate(:to='getRoute("/materials/setups/" + matSetup.id)') {{ matSetup.name }}
          +info('Detector Setup')(v-if='$butils.isNil(run.detSetupId)') Not Set
          +info('Detector Setup')(v-else-if='!detSetupLoading && detSetup')
            router-link.text-primary.text-truncate(:to='getRoute("/detectors/setups/" + detSetup.id)') {{ detSetup.name }}

        li(v-if='run && !runLoading && inEdit' key='edit')
          .row.b-param-container
            BaseParamInput.col-12.col-sm-9(ref='title' title='Title' :inEdit='true' :value='run.title')
        li.x-desc.x-desc(v-if='run && !runLoading' key='desc')
          BaseCollapsible(:expand='true' title='Description')
            template(v-slot:header)
              strong Description
            BaseMarkdownWidget(ref='description' :inEdit='inEdit' :value='run.description')
        li.x-config(v-if='run && !runLoading' key='config')
          BaseCollapsible.x-daq-config(@update:expand='setShowConfig($event)')
            template(v-slot:header='')
              strong Channels Configuration
            DAQConfig(v-if='showConfig' :runNumber='run.runNumber')
        li(v-if='run && !runLoading' key='hv-config')
          HVConfig(:runNumber='run.runNumber')
        li.x-comments(v-if='run && !runLoading' key='comments')
          CommentsList(:run='run' :inEdit='inEdit' :expand='true')
        li.x-docs(v-if='run && !runLoading' key='docs')
          DocumentsList(:inEdit='inEdit' parentType='runs' :parentItem='run')
        li.x-triggers(v-if='run && !runLoading' key='triggers')
          TriggersList(:runNumber="run.runNumber")
        li(v-if='run && !loading && inEdit' key='submit')
          .d-flex.justify-content-end
            router-link.btn.btn-outline-danger.ml-1.x-admin(v-if='!isAdmin && $store.getters.canAdmin' :to='`/admin/runs/${id}`' title='admin')
              i.fa.fa-key
            button.btn.btn-primary.mx-1.x-submit(@click="doSubmit()")
              kbd.keyHint.mr-2(v-if="showKeyHints") Ctrl+S
              i.fa.fa-upload.mr-1(v-else)
              | Submit
      EditDataStatusDialog(ref='editDataStatusDialog')
</template>
<script>
export { default } from './RunInfo.vue.js';
</script>
<style lang='scss'>
.x-runinfo {
  .b-markdown-preview {
    padding-top: .75rem;
    padding-left: 15px;
    padding-right: 15px;
  }
  .x-desc {
    // preview ribbon must be over other elts
    z-index: 1;
  }
}
</style>
